`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    22:58:17 08/31/2009 
// Design Name: 
// Module Name:    StateMachineWorld 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module StateMachineWorld_ROM(
    input BTN1,
    input BTN2,
    input BTN3,
    input CLK,
    input RESET,
    output [2:0] STATE_OUT
    );

reg [2:0] Next_State [0:63] ;
reg [2:0] Current_State ;

initial $readmemb("SM_Mem.dat", Next_State );

always@(posedge CLK) begin
	if(RESET)
		Current_State <= 3'b000;
	else
		Current_State <= Next_State[{Current_State, BTN3, BTN2, BTN1}]; 
end

assign STATE_OUT = Current_State;

endmodule
